;==============================================;
;MulDeR v1.0 by Philippe Gervaise aKa CandyMan ;
;                                              ;
;                   FINAL                      ;
;                                              ;
; It's an demonstration on using fontlib and   ;
;  browslib (fontlib is available on my site). ;
;                                              ;
;MULti DocumEnt Reader V1.0 !!                 ;
;^^^   ^    ^   ^                              ;
;|||   |    |   |                              ;
;==============================================;
;Web site : http://www.i-france.com/candyman   ;
;E-Mail : CandyMan@I-France.com                ;
;==============================================;
;Be sure E.T. isn't watching this behind you :p;
;==============================================;

;Includes part
      include "..\doorsos.h"
      include "..\graphlib.h"
	include "..\fontlib.h"
	include "..\browslib.h"

;Definition part
      xdef _main
      xdef _comment
      xdef _ti89


;Macro call :
;WriteStrFont X, Y, String
;X -> word, horizontale coordinate
;Y -> word, verticale coordinate
;String -> Long, address of the string to write

WriteStrFont MACRO                ;Write with the CurrentFont
	move.w \1,d0                ;We will write on x
	move.w \2,d1                ;We will write on y
	move.l \3,a0                ;Store string address in a0
	jsr fontlib::WriteString    ;Write the string stored at a0
	ENDM

;===============================================================================
;Program start here ( _main )
;===============================================================================

_main
	move.w #0,NFile

	bsr ChangeInt
	bsr OpenAFile
	tst.w NFile
	bne ViewFile                           ;Yes -> View this file !

	bsr RestoreInt
	rts                                    ;No -> Quit ...

ViewFile:
	bsr GetLineNumber                      ;Get text line nimber
	move.w #0,CurrentLine                  ;Set CurrentLine to 0
	move.w #0,CurrentChar                  ;Set CurrentChar to 0

	bsr InitScreen                         ;Initialize the screen
	bsr DrawScreenInfo                     ;Display some info on the screen


	tst.l CurrentFont                      ;No font selected ?
	beq UseInternalFont

	move.l CurrentFont,a0
	cmp.l #'_Fnt',(a0)                     ;Font is valid ?
	beq UseFont

UseInternalFont:
	move.l #font,a0                        ;Get Font address
	move.l a0,CurrentFont
UseFont:
	jsr fontlib::InitFont                  ;Initialize font

	bsr GetNLineOnScr                      ;Get number of lines on screen with
                                             ;the current font

	move.w #0,d4                           ;Start drawing at first char
	move.w NCharOnScr,d5                   ;Draw NCharOnScr chars per line
	move.w #0,d6                           ;Start drawing at first line
	move.w NLineOnScr,d7                   ;Draw NLineOnScr lines
	bsr DrawText                           ;Draw text data

MainLoop
	move.w #%11111011,d0        ;For 9, 6, 3
	bsr GetKey

	btst #3,d0
	beq Key9
	btst #2,d0
	beq Key6
	btst #1,d0
	beq Key3

	move.w #%11110111,d0        ;For 8, 5, 2, Catalog
	bsr GetKey
	btst #6,d0
	beq OpenNewFile
	btst #3,d0
	beq Key8
	btst #2,d0
	beq Key5
	btst #1,d0
	beq Key2

	move.w #%11101111,d0        ;For 7, 4, 1, 0
	bsr GetKey

	btst #3,d0
	beq Key7
	btst #2,d0
	beq Key4
	btst #1,d0
	beq Key1
	btst #0,d0
	beq Key0

	move.w #%11111110,d0        ;pour les touches de directions
	bsr GetKey

	btst #2,d0
	beq KeyDown

	btst #0,d0
	beq KeyUp

	btst #1,d0
	beq KeyLeft

	btst #3,d0
	beq KeyRight

	move.w #%11101111,d0        ;For opening a font
	bsr GetKey

	btst #6,d0
	beq KeyChangeFont

	move.w #%10111111,d0        ;for Esc key
	bsr GetKey

	btst #0,d0
	beq EndProg

	bra MainLoop

EndProg:
	bsr RestoreInt
	rts

;===============================================================================
;For keyboard
;===============================================================================
KeyDown:
      move.w NLine,d0
	cmp.w NLineOnScr,d0         ;More lines in the text than on the screen ?
	ble MainLoop                ;Yes -> Skip scrolling

	move.w CurrentLine,d0       ;Current line in text
	add.w NLineOnScr,d0         ;Add number of lines on screen
	add.w #1,d0                 ;inc d0 by 1

	cmp.w NLine,d0              ;Is there a line under the screen ?
	bhi MainLoop                ;No -> Skip scrolling

	add.w #1,CurrentLine        ;Current line change
	bsr ScrollUp

	move.w #0,d4                ;Start drawing at first char
	move.w NCharOnScr,d5        ;Draw NCharOnScr chars per line
	move.w NLineOnScr,d6
	sub.w #1,d6                 ;Start at line NLineOnScr
	move.w #1,d7                ;Draw one line
	bsr DrawText

	bra MainLoop

KeyUp:
	tst.w CurrentLine
	beq MainLoop

	sub.w #1,CurrentLine
	bsr ScrollDown

	move.w #0,d4                ;Start drawing at first char
	move.w NCharOnScr,d5        ;Draw NCharOnScr chars per line
	move.w #0,d6                ;Start with first line
	move.w #1,d7                ;Draw 1 line
	bsr DrawText

	bra MainLoop

KeyLeft:
	tst.w CurrentChar
	beq MainLoop

	sub.w #1,CurrentChar

	bsr ScrollRight

	move.w #0,d4                ;Start drawing at first char
	move.w #1,d5                ;Draw 1 char per line
	move.w #0,d6                ;Start drawing at first line
	move.w NLineOnScr,d7        ;Draw NLineOnScr lines
	bsr DrawText

	bra MainLoop

KeyRight:
      move.w MaxChar,d0
	cmp.w NCharOnScr,d0         ;More chars per line in the text than on the screen ?
	ble MainLoop                ;Yes -> Skip scrolling

	move.w CurrentChar,d0       ;Current char in line
	add.w NCharOnScr,d0         ;Add number of char per line on screen
	add.w #1,d0                 ;inc d0 by 1

	cmp.w MaxChar,d0            ;Is there a char at the right of the screen ?
	bhi MainLoop                ;No -> Skip scrolling

	add.w #1,CurrentChar

	bsr ScrollLeft

	move.w NCharOnScr,d4        ;Start drawing at last char
	sub.w #1,d4                 ;
	move.w #1,d5                ;Draw 1 char per line
	move.w #0,d6                ;Start drawing at first line
	move.w NLineOnScr,d7        ;Draw NLineOnScr lines
	bsr DrawText

	bra MainLoop

KeyChangeFont
	move.l #FontMask,browslib::MaskAddr    ;Get Font mask for library BrowsLib
	move.l #Title3,browslib::DownTitleAddr ;
	bsr RestoreInt
	jsr browslib::OpenFile                 ;Display the browser
	bsr ChangeInt
	tst.l browslib::FileResult             ;A file was selected ?
	bne SetNewFont                         ;Yes -> Use new font

	bsr RestoreScreen
	bra MainLoop

SetNewFont:
	bsr InitScreen                         ;ReDraw the screen
	bsr DrawScreenInfo                     ;

	move.l browslib::FileResult,a0         ;Get Font VAT address
	lea 12(a0),a0                          ;Go to handle address
	move.w (a0),d0                         ;Get file handle
	DEREF d0,a0                            ;Get file address with handle d0
	addq #2,a0                             ;Skip file size
	move.l a0,CurrentFont                  ;Save font address
	jsr fontlib::InitFont                  ;Initialize font

	bsr GetNLineOnScr                      ;Get number of lines on screen with
                                             ;the current font

	move.w #0,d4                           ;Start drawing at first char
	move.w NCharOnScr,d5                   ;Draw NCharOnScr chars per line
	move.w #0,d6                           ;Start drawing at first line
	move.w NLineOnScr,d7                   ;Draw NLineOnScr lines
	bsr DrawText                           ;Draw text with the new font
	bra MainLoop                           ;Go to MainLoop

Key9:
	move.w #9,d0
	bra KeyChangeFile
Key8:
	move.w #8,d0
	bra KeyChangeFile
Key7:
	move.w #7,d0
	bra KeyChangeFile
Key6:
	move.w #6,d0
	bra KeyChangeFile
Key5:
	move.w #5,d0
	bra KeyChangeFile
Key4:
	move.w #4,d0
	bra KeyChangeFile
Key3:
	move.w #3,d0
	bra KeyChangeFile
Key2:
	move.w #2,d0
	bra KeyChangeFile
Key1:
	move.w #1,d0
	bra KeyChangeFile
Key0:
	move.w #0,d0
	bra KeyChangeFile

KeyChangeFile:
	cmp.w NFile,d0
	bge MainLoop

	cmp.w CurrentFile,d0                   ;No change ?
	beq MainLoop

	bsr SaveCurrentPos

	move.w d0,CurrentFile
	move.l #Files,a2
	lsl.w #3,d0
	add.w d0,a2
	move.l (a2)+,a0
	move.w -2(a0),TextSize
	move.l a0,TextAddr

	move.w (a2)+,CurrentLine               ;Set CurrentLine
	move.w (a2),CurrentChar                ;Set CurrentChar
	bsr GetLineNumber                      ;Get text line number


	bsr RestoreScreen

	bra MainLoop

OpenNewFile:
	bsr SaveCurrentPos

	move.w NFile,d0
	bsr OpenAFile
	cmp.w NFile,d0
	beq NoNewFile

	bsr GetLineNumber                      ;Get text line number
	move.w #0,CurrentLine                  ;Set CurrentLine to 0
	move.w #0,CurrentChar                  ;Set CurrentChar to 0

NoNewFile:
	bsr RestoreScreen
	bra MainLoop

;===============================================================================
;Save CurrentLine and CurrentChar in the memory before changing file
;===============================================================================
SaveCurrentPos:
	move.l d0,-(a7)
	move.w CurrentFile,d0
	move.l #Files,a2
	lsl.w #3,d0
	add.w d0,a2
	move.l TextAddr,(a2)+
	move.w CurrentLine,(a2)+
	move.w CurrentChar,(a2)
	move.l (a7)+,d0
	rts

;===============================================================================
;Get number of lines that can be displayed in one time on the screen
;Get also number of chars that can be displayed in one time on the screen
;===============================================================================
GetNLineOnScr:
	movem d0-d1,-(a7)
	moveq #0,d0                 ;Set d0 to 0
	move.b fontlib::FontY,d0    ;Get font vertical size (move.b, not move.w !)
	addq #1,d0                  ;Add 1 to d0 (d0 = FontY + 1)

	move.l #80,d1               ;Set d1 to 80 (text viewing resolution)
	divu d0,d1                  ;d1 = 80 div (FontY + 1)
	move.w d1,NLineOnScr

	move.b fontlib::FontX,d0    ;Get font horizontale size
	add.w fontlib::SpaceX,d0    ;Get space between chars

	move.l #153,d1              ;Set d1 to 153 (nb of pixels for chars)
	divu d0,d1                  ;d1 = 153 div (FontX + SpaceX)
	move.w d1,NCharOnScr

	movem (a7)+,d0-d1
	rts

;===============================================================================
;Restore Screen as previous
;===============================================================================
RestoreScreen
	bsr InitScreen
	bsr DrawScreenInfo
	move.l CurrentFont,a0                  ;Get Current font address
	jsr fontlib::InitFont                  ;Initialize font

	move.w #0,d4                           ;Start drawing at first char
	move.w NCharOnScr,d5                   ;Draw NCharOnScr chars per line
	move.w #0,d6                           ;Start drawing at first line
	move.w NLineOnScr,d7                   ;Draw NLineOnScr lines
	bsr DrawText
	rts

;===============================================================================
;Init screen
;===============================================================================

;Draw a bar on the right (Current line bar)
DrawRightBar:
	move.w #156,d0              ;Draw a Top Arrow at (156,8)
	move.w #8,d1                ;
	move.l #TopArrow,a0         ;
	jsr graphlib::put_sprite_mask

	move.w #156,d0              ;Draw a Bottom Arrow at (156,84)
	move.w #84,d1               ;
	move.l #BottomArrow,a0      ;
	jsr graphlib::put_sprite_mask
	rts

UpDateRightBar:
	move.w NLine,d0
	cmp.w NLineOnScr,d0         ;Is there more lines in the text that on the screen ?
	bhi \UpDateNeeded           ;Yes -> Draw the right bar
	rts
\UpDateNeeded:

	move.w #156,d0
	move.w #13,d1
	move.w #2,d2
	move.w #70,d3
	move.w #1,d4

	jsr graphlib::fill

	move.w CurrentLine,d5
	mulu #71,d5
	divu NLine,d5
	add.w d5,d1

	move.w NLineOnScr,d3
	mulu #71,d3
	divu NLine,d3

	move.w #2,d4
	jsr graphlib::fill

	rts

UpDateBottomBar:
	move.w MaxChar,d0
	cmp.w NCharOnScr,d0         ;Is there more chars in the text that on the screen ?
	bhi \UpDateNeeded           ;Yes -> Draw the right bar
	rts
\UpDateNeeded:

	move.w #6,d0
	move.w #90,d1
	move.w #143,d2
	move.w #2,d3
	move.w #1,d4

	jsr graphlib::fill

	move.w CurrentChar,d5
	mulu #144,d5
	divu MaxChar,d5
	add.w d5,d0

	move.w NCharOnScr,d2
	mulu #144,d2
	divu MaxChar,d2

	move.w #2,d4
	jsr graphlib::fill
	rts

InitScreen:
	jsr graphlib::clr_scr       ;Clear the screen

	move.w #%11111111,d3        ;Mask for PutSprite
	move.w #1,d0                ;Draw a Left Arrow at (1,90)
	move.w #90,d1               ;
	move.l #LeftArrow,a0        ;
	jsr graphlib::put_sprite_mask

	move.w #150,d0              ;Draw a Right Arrow at (150,90)
	move.w #90,d1               ;
	move.l #RightArrow,a0       ;
	jsr graphlib::put_sprite_mask

	bsr DrawRightBar            ;Draw rigth bar

	move.w #0,d0                ;Do a frame all around the screen
	move.w #0,d1                ;
	move.w #159,d4              ;
	move.w #99,d5               ;
	jsr graphlib::frame         ;

	move.w #7,d1                ;First horizontal line (under title)
	move.w #159,d2              ;
	move.w #2,d3                ;
	jsr graphlib::horiz         ;

	move.w #89,d1               ;Second horizontal line (under text)
	jsr graphlib::horiz         ;
	move.w #93,d1               ;Third horizontal line (over text "F1 = HELP")
	jsr graphlib::horiz         ;

	move.w #155,d0              ;Vertical line (left scoller)
	move.w #8,d1                ;
	move.w #92,d2               ;
	jsr graphlib::vert          ;

	rts

;===============================================================================
;Draw screen informations (with little font)
;===============================================================================
DrawScreenInfo:
                                  ;We choose the little font stored in this file
	move.l #font,a0             ;a0 are the font data, address of "font"
	jsr fontlib::InitFont       ;Now initialize the font (at a0)

	clr.w fontlib::SpaceX       ;Put no space between Chars
	move.w #0,fontlib::Recover  ;Font backround is keeped

	WriteStrFont #27,#1,#_comment          ;Write comment string (author)
	WriteStrFont #53,#94,#HelpCommand      ;Write "F1 = HELP"

	move.w NFile,d0
	move.l #NFileStr,a0
	move.b #32,(a0)+
	bsr writed0
	WriteStrFont #5,#94,#NFileStr
	rts

;===============================================================================
;Get number of lines in the text and number of max chars per line
;===============================================================================
GetLineNumber:
	move.l TextAddr,a0          ;Get text address
	addq #2,a0                  ;Skip current position (word)
	move.w #1,NLine             ;There is at least one line
	move.w #0,MaxChar           ;No chars by default

	move.w TextSize,d0          ;Use size of the text in bytes
	sub.w #5,d0                 ;Search in TextSize - 4 bytes

	move.w #0,d1                ;d1 -> Number of chars in the current line

NextChar:
	add.w #1,d1
	cmp.b #13,(a0)+             ;End of line ?
	bne NoNewLine               ;No -> Skip next line
	add.w #1,NLine              ;Character 13 -> New line found !
	sub.w #2,d1                 ;Real number of chars (because of #13, #32)
	cmp.w MaxChar,d1            ;Found more characters than MaxChar ?
	ble NoChangeMaxChar         ;No -> Skip next part
	move.w d1,MaxChar           ;New number of chars

NoChangeMaxChar:
	move.w #0,d1                ;Reset number of chars

NoNewLine:

	dbra.w d0,NextChar          ;Is there any char left ?
	rts                         ;End of text -> Quit

;===============================================================================
;Draw text (or some lines) from file on screen
;Input : 
;  d4.w -> FirstChar (0-??)
;  d5.w -> Number of chars (1-??)
;
;  d6.w -> FirstLine (0-??)
;  d7.w -> Number of Lines (1-??)
;===============================================================================
DrawText:
	move.l d5,-(a7)
	move.l d4,-(a7)

	move.l TextAddr,a0          ;a0 -> Text data
	addq #3,a0                  ;Skip current position (word) and space


;Go to the current line
	move.w CurrentLine,d0       ;
	tst.w d0                    ;First Line of the text ?
	beq CorrectLine             ;Yes -> Go directly to CorrectLine

	sub.w #1,d0                 ;
SkipLine:

SearchSkipNextLine:
	cmp.b #13,(a0)+             ;
	bne SearchSkipNextLine      ;

	dbra.w d0,SkipLine          ;

	addq #1,a0                  ;Skip char 32

CorrectLine:

	clr.w d3                    ;d3 -> Current Line (in file)
	move.w #9,d1                ;d1 -> Current Y position on screen

;Start drawing strings on the screen

DrawNextLine:
	add.w #1,d3
	move.w #2,d0                ;d0 -> Current X Position on screen

;Go the current first char
	tst.w CurrentChar
	beq CorrectChar             ;No change needed

	move.w CurrentChar,d3
	sub.w #1,d3
SkipChar:
	cmp.b #13,(a0)              ;if char #13 (Enter), end of change
	beq CorrectChar

;??!!!!!!!!!!!!!!!!!!!!0 char here !!!!!!!!!!!!!!!!!!??
	addq #1,a0
	dbra.w d3,SkipChar

CorrectChar:
	clr.w WriteMode             ;Write mode = 0; draw chars
	move.l #StrToWrite,a2       ;Get the buffer string

DrawNextChar:

	tst.w WriteMode
	bne AfterLineEnd

	move.b (a0)+,d2             ;Put the char on d2
	cmp.b #13,d2
	bne WriteCharToMem
	subq #1,a0                  ;Pointer to the char #13
	move.w #1,WriteMode
	beq WriteCharToMem

AfterLineEnd:
	move.b #32,d2

WriteCharToMem:
	tst.w d4                    ;Can start taking chars ?
	beq ReallyWrite

	sub.w #1,d4
	bra AfterWriteToMem

ReallyWrite:

	tst.w d5                    ;End of taking chars ?
	beq AfterWriteToMem

	sub.w #1,d5
	move.b d2,(a2)+

AfterWriteToMem
;	tst.b d2
;	beq EndScreen               ;d2 = 0 -> End of file

	add.b fontlib::FontX,d0     ;FontX is a BYTE (be careful ...)
	add.w fontlib::SpaceX,d0    ;Number of Spaces between each chars (in pixels)

	move.w #156,d2
	sub.b fontlib::FontX,d2
	cmp.w d2,d0                 ;Out of screen ?
	blt DrawNextChar            ;No = continue, Yes = Stop writing line

	tst.w d6                    ;First line to write is reached ? (Input parameter)
	beq TestPassed              ;Yes -> Continue
	sub.w #1,d6
	bra SearchNextLine

TestPassed:
	tst.w d7                    ;End of writing (Input parameter) ?
      beq EndScreen               ;Yes -> Exit

	sub.w #1,d7                 ;Write one another line

	move.l (a7),d4              ;Get d4 from the stack
	moveq #0,d0
	move.b fontlib::FontX,d0
	add.w fontlib::SpaceX,d0
	mulu d4,d0
	add.w #2,d0

	move.l a0,-(a7)

	move.b #0,(a2)              ;End of string
	move.l #StrToWrite,a0
	jsr fontlib::WriteString    ;Write the buffer string

	move.l (a7)+,a0

SearchNextLine:

	move.l 4(a7),d5             ;Get d5 from the stack

	cmp.w NLine,d3
	bge EndScreen

	cmp.b #13,(a0)+             ;Search for Carriage return
	bne SearchNextLine

EndLine:
	addq #1,a0                  ;Skip char 32 (after new line)

	add.b fontlib::FontY,d1     ;Set new Y Position
	add.b #1,d1                 ;For space between chars

	move.w #88,d2               ;
	sub.b fontlib::FontY,d2     ;
	cmp.w d2,d1                 ;Y Position out of screen ?
	blt DrawNextLine

EndScreen:

	bsr UpDateRightBar
	bsr UpDateBottomBar
;	bsr UpDatePercent
;	move.l (a7)+,d4
;	move.l (a7)+,d5
	lea 8(a7),a7
	rts


;===============================================================================
;Do a scrolling (text moved to the top)
;Hard to explain how it work ...
;===============================================================================
ScrollUp:
	move.l #LCD_MEM,a0          ;Get Screen address
	add.l #240,a0               ;240 = 30 * 8 -> Skip 8 lines

	moveq #0,d0
	move.b fontlib::FontY,d0    ;Get Vertical size for font
	addq #1,d0                  ;Include vertical space between two lines

	move.w #80,d7
	sub.w d0,d7

	mulu #30,d0                 ;30 bytes per line, d0 = (FontY + 1) * 30
	move.l a0,a2
	add.w d0,a2

UpY:
	move.w #19,d6               ;To move 20 bytes
UpX:
	tst.w d6                    ;Last Byte of line ?
	bne \NotLastByte            ;No -> Skip next part
      move.b (a2)+,d0             ;Take byte
	and.b #%11110000,d0         ;"Destroy" the first 4 bits
      and.b #%00001111,(a0)       ;"Destroy" the last 4 bits
	or.b d0,(a0)+               ;Put remaining bits in a0

	add.l #10,a0                ;Next line
	add.l #10,a2                ;Next line

	dbra.w d7,UpY               ;End of screen ?
	rts

\NotLastByte:

	move.b (a2)+,(a0)+          ;Scroll bytes
	dbra.w d6,UpX               ;End of line ?

;===============================================================================
;Do a scrolling (text moved to the bottom)
;Hard to explain how it work ...
;===============================================================================
ScrollDown:
	move.l #LCD_MEM,a0          ;Get Screen address

	moveq #0,d0                 ;Set d0 to 0
	move.b fontlib::FontY,d0    ;Get font vertical size (move.b, not move.w !)
	addq #1,d0                  ;Add 1 to d0 (d0 = FontY + 1)

	move.l #80,d1               ;Set d1 to 80 (text viewing resolution)
	divu d0,d1                  ;d1 = 80 div (FontY + 1)


	mulu d0,d1                  ;d1 = ( 80 div (FontY + 1) ) * (FontY + 1)
	move.w d1,d2                ;d2 = Number of vertical lines for text viewing

	add.w #8,d1
	mulu #30,d1                 ;d1 = (7 + (80 div (FontY + 1) ) * (FontY + 1) ) * 30
                                  ;30 -> Number of bytes for a line on screen
	add.w d1,a0

	move.l a0,a2

	mulu #30,d0                 ;30 bytes per line, d0 = (FontY + 1) * 30
	sub.w d0,a2                 ;a2 is the string line under a0


	move.w d2,d7
	sub.b fontlib::FontY,d7
	sub.w #2,d7
DownY:
	sub.l #10,a0
	sub.l #10,a2

      move.b -(a2),d0             ;Take byte
	and.b #%11110000,d0         ;"Destroy" the first 4 bits
      and.b #%00001111,-(a0)      ;"Destroy" the last 4 bits
	or.b d0,(a0)                ;Put remaining bits in a0

	move.w #18,d6
DownX:
	move.b -(a2),-(a0)
	dbra.w d6,DownX

	dbra.w d7,DownY
	rts

;===============================================================================
;Do a scrolling (text moved to the right, per 1 bit)
;Hard to explain how it work ...
;===============================================================================
ScrollRight:
	moveq #0,d5
	move.b fontlib::FontX,d5
	add.w fontlib::SpaceX,d5
	subq #1,d5
ScreenRight:

      move.l #LCD_MEM,a0
	add.l #270,a0

	move.w #79,d7
RightY:
	move.l a0,a2                ;Save current screen position

	and.b #%01111111,(a0)
	moveq #1,d0
	lsr.b #1,d0

	move.w #8,d6                ;We want to shift 9 words
RightX:
	roxr.w (a0)+                ;Rotate to the right with Extended bit (easy no ?)
	dbra d6,RightX              ;Is there any word left ?

	move.w (a0),d0              ;Now rotate word that contain the right bar
	roxr.w #1,d0                ;This rotate bits but keep right bar intact
	and.b #%11000000,d0
	moveq #0,d1
	move.w (a0),d1
	and.w #%0000000000111111,d1
	or.w d1,d0
	move.w d0,(a0)+

;Delete a bit after chars on a line (because of the shifting)
	moveq #0,d0
	move.b fontlib::FontX,d0
	add.w fontlib::SpaceX,d0
	mulu NCharOnScr,d0
	add.w #2,d0

	move.w d0,d1
	lsr.w #3,d1
	add.w d1,a2                 ;a2 is now on the byte where the bit will be clear
	and.w #7,d0

	move.w #7,d1
	sub.w d0,d1

	moveq #1,d0
	lsl d1,d0

	move.b #255,d1
	sub.b d0,d1
	and.b d1,(a2)

	add.l #10,a0
	dbra d7,RightY              ;Is there any line left ?

	dbra d5,ScreenRight
	rts

;===============================================================================
;Do a scrolling (text moved to the left, per 1 bit)
;Hard to explain how it work ...
;===============================================================================
ScrollLeft:
	moveq #0,d5
	move.b fontlib::FontX,d5
	add.w fontlib::SpaceX,d5
	subq #1,d5
ScreenLeft:

      move.l #LCD_MEM,a0
	add.l #2660,a0

	move.w #79,d7
LeftY:

	move.w -(a0),d0                 ;To keep right bar, process last word first
	lsl.w #1,d0                     ;
	and.w #%11111111111110000000,d0 ;
	move.w (a0),d1                  ;
	and.w #%00000000000000111111,d1 ;
	or.w d1,d0                      ;
	move.w d0,(a0)

	move.w #8,d6                ;We want to shift 9 words
LeftX:
	roxl.w -(a0)                ;Rotate to the left with Extended bit (easy no ?)
	dbra d6,LeftX               ;Is there any word left ?

	and.b #%00111111,(a0)       ;To keep left line
	or.b #%10000000,(a0)        ;

	sub.l #10,a0
	dbra d7,LeftY               ;Is there any line left ?

	dbra d5,ScreenLeft
	rts

;===============================================================================
;Open one more file
;===============================================================================
OpenAFile:
	move.l #TextMask,browslib::MaskAddr    ;Address of the file mask
	move.l #Title1,browslib::UpTitleAddr   ;Address of the upper title
	move.l #Title2,browslib::DownTitleAddr ;Address of the lower title
	bsr RestoreInt
	jsr browslib::OpenFile                 ;Select a file
	bsr ChangeInt
	tst.l browslib::FileResult             ;A file was selected ?
	beq EndOfOpen

	move.w NFile,d0
	move.w d0,CurrentFile

	add.w #1,NFile

	move.l browslib::FileResult,a0
	lea 12(a0),a0                          ;Go to handle address
	move.w (a0),d7                         ;Retrieve file handle
	DEREF d7,a0                            ;Get file address with handle

	move.w (a0)+,TextSize

	move.l #Files,a2
	lsl.w #3,d0
	add.w d0,a2
	move.l a0,(a2)+
	move.w #0,(a2)+
	move.w #0,(a2)

	move.l a0,TextAddr

EndOfOpen:
	rts


;===============================================================================
;Write a number on a string
;===============================================================================
writed0:
	moveq #0,d1
	divu #10,d0                 ;apres, d0->prochain nombre,d1->chiffre voulu
	swap d0
	move.w d0,d1
	clr.w d0
	swap d0                     ;d0 -> prochain nombre; d1 -> chiffre a afficher

	add.b #48,d1                ;on affiche le chiffre
	move.b d1,(a0)              ;on le met dans la chaine
	sub.l #1,a0                 ;on modifie le pointeur sur la chaine

	tst.w d0                    ;on regarde s'il reste encore des chiffres
	bne writed0
	rts

;===============================================================================
;Recupere la valeur du port clavier
;===============================================================================

GetKey:
	move.w d0,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	moveq #0,d0
	move.b ($60001B),d0
	rts

;===============================================================================
;Hook the timer interrupt
;===============================================================================

;---- Put our own timer ----
ChangeInt:
	moveq #0,d0
	move.w	#$0700,d0            ;New SR register -> Disable all interrupts
	trap #1                     ;Change the SR register
	bclr.b #2,($600001)         ;Change to Supervisor mode
	move.l ($64),OldInterrupt   ;Save old Interrupt address on Vector Table
	move.l #NewInterrupt,($64)  ;Put new Interrupt address on Vector Table
	bset.b #2,($600001)         ;Change to User mode
	trap #1                     ;
	rts

;---- Restore old timer ----
RestoreInt:
	moveq #0,d0
	move.w #$0700,d0            ;New SR register -> Disable all interrupts
	trap #1                     ;Change the SR register
	bclr.b #2,($600001)         ;Change to Supervisor mode
	move.l OldInterrupt,($64)   ;Restore old interrupt address into vector table
	bset.b #2,($600001)         ;Change to user mode
	trap #1                     ;
	rts

;---- Called every 1/350 s ----
NewInterrupt:
	rte


;===============================================================================
;Start of data segment
;===============================================================================

;Font generated by FontMaker by CandyMan
;FontMaker is included with FontLib
;You can get FontLib at http://www.i-france.com/candyman
font:           ;Font data (4x6, chars 32 to 126)
 dc.l "_Fnt"    ;Identification
 dc.w 1         ;Version (1)
 dc.w 0         ;Misc word
 dc.w 95        ;Number of chars
 dc.w 32        ;First char code
 dc.b 6         ;Horizontal size of the chars
 dc.b 4         ;Vertical size of the chars
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00100010
 dc.b %00100000
 dc.b %00100000
 dc.b %01010101
 dc.b %00000000
 dc.b %00000000
 dc.b %01010111
 dc.b %01010111
 dc.b %01010000
 dc.b %00100011
 dc.b %01100011
 dc.b %01100010
 dc.b %01000001
 dc.b %00100100
 dc.b %00010000
 dc.b %00100101
 dc.b %00110101
 dc.b %01110000
 dc.b %01100100
 dc.b %00000000
 dc.b %00000000
 dc.b %00100100
 dc.b %01000100
 dc.b %00100000
 dc.b %01000010
 dc.b %00100010
 dc.b %01000000
 dc.b %01010010
 dc.b %01110010
 dc.b %01010000
 dc.b %00000010
 dc.b %01110010
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %01100100
 dc.b %00000000
 dc.b %01110000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00100000
 dc.b %00010001
 dc.b %00100100
 dc.b %01000000
 dc.b %00110101
 dc.b %01010101
 dc.b %01100000
 dc.b %00100110
 dc.b %00100010
 dc.b %01110000
 dc.b %01100001
 dc.b %00100100
 dc.b %01110000
 dc.b %01100001
 dc.b %00100001
 dc.b %01100000
 dc.b %00010101
 dc.b %01110001
 dc.b %00010000
 dc.b %01110100
 dc.b %01100001
 dc.b %01100000
 dc.b %00100100
 dc.b %01100101
 dc.b %00100000
 dc.b %01110001
 dc.b %00110010
 dc.b %00100000
 dc.b %00100101
 dc.b %00100101
 dc.b %00100000
 dc.b %00100101
 dc.b %00110001
 dc.b %00100000
 dc.b %00000000
 dc.b %00100000
 dc.b %00100000
 dc.b %00000000
 dc.b %00100000
 dc.b %01100100
 dc.b %00010010
 dc.b %01000010
 dc.b %00010000
 dc.b %00000000
 dc.b %01110000
 dc.b %01110000
 dc.b %01000010
 dc.b %00010010
 dc.b %01000000
 dc.b %01100001
 dc.b %00100000
 dc.b %00100000
 dc.b %01110101
 dc.b %01010100
 dc.b %01110000
 dc.b %00100101
 dc.b %01110101
 dc.b %01010000
 dc.b %01100101
 dc.b %01100101
 dc.b %01100000
 dc.b %00110100
 dc.b %01000100
 dc.b %00110000
 dc.b %01100101
 dc.b %01010101
 dc.b %01100000
 dc.b %01110100
 dc.b %01100100
 dc.b %01110000
 dc.b %01110100
 dc.b %01100100
 dc.b %01000000
 dc.b %00110100
 dc.b %01010101
 dc.b %00110000
 dc.b %01010101
 dc.b %01110101
 dc.b %01010000
 dc.b %01110010
 dc.b %00100010
 dc.b %01110000
 dc.b %00010001
 dc.b %00010101
 dc.b %00100000
 dc.b %01010101
 dc.b %01100101
 dc.b %01010000
 dc.b %01000100
 dc.b %01000100
 dc.b %01110000
 dc.b %01010111
 dc.b %01110101
 dc.b %01010000
 dc.b %01010111
 dc.b %01010101
 dc.b %01010000
 dc.b %00100101
 dc.b %01010101
 dc.b %00100000
 dc.b %01100101
 dc.b %01100100
 dc.b %01000000
 dc.b %00100101
 dc.b %01010111
 dc.b %00110000
 dc.b %01100101
 dc.b %01100101
 dc.b %01010000
 dc.b %00110100
 dc.b %01110001
 dc.b %01100000
 dc.b %01110010
 dc.b %00100010
 dc.b %00100000
 dc.b %01010101
 dc.b %01010101
 dc.b %01110000
 dc.b %01010101
 dc.b %01010101
 dc.b %00100000
 dc.b %01010101
 dc.b %01110111
 dc.b %01010000
 dc.b %01010101
 dc.b %00100101
 dc.b %01010000
 dc.b %01010101
 dc.b %00100010
 dc.b %00100000
 dc.b %01110001
 dc.b %00100100
 dc.b %01110000
 dc.b %01100100
 dc.b %01000100
 dc.b %01100000
 dc.b %01000100
 dc.b %00100001
 dc.b %00010000
 dc.b %01100010
 dc.b %00100010
 dc.b %01100000
 dc.b %00100101
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00001111
 dc.b %01100010
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000
 dc.b %00110101
 dc.b %01110000
 dc.b %01000100
 dc.b %01100101
 dc.b %01100000
 dc.b %00000000
 dc.b %00110100
 dc.b %00110000
 dc.b %00010001
 dc.b %00110101
 dc.b %00110000
 dc.b %00000000
 dc.b %01110110
 dc.b %00110000
 dc.b %00010010
 dc.b %01110010
 dc.b %00100000
 dc.b %00000000
 dc.b %01110101
 dc.b %00010111
 dc.b %01000100
 dc.b %01100101
 dc.b %01010000
 dc.b %00100000
 dc.b %00100010
 dc.b %00100000
 dc.b %00100000
 dc.b %00100010
 dc.b %00100110
 dc.b %01000100
 dc.b %01010110
 dc.b %01010000
 dc.b %00100010
 dc.b %00100010
 dc.b %00100000
 dc.b %00000000
 dc.b %01110111
 dc.b %01010000
 dc.b %00000000
 dc.b %01100101
 dc.b %01010000
 dc.b %00000000
 dc.b %00100101
 dc.b %00100000
 dc.b %00000000
 dc.b %01100101
 dc.b %01100100
 dc.b %00000000
 dc.b %00110101
 dc.b %00110001
 dc.b %00000000
 dc.b %01100100
 dc.b %01000000
 dc.b %00000000
 dc.b %00110010
 dc.b %01100000
 dc.b %00000010
 dc.b %01110010
 dc.b %00110000
 dc.b %00000000
 dc.b %01010101
 dc.b %01110000
 dc.b %00000000
 dc.b %01010101
 dc.b %00100000
 dc.b %00000000
 dc.b %01010111
 dc.b %01110000
 dc.b %00000000
 dc.b %01010010
 dc.b %01010000
 dc.b %00000000
 dc.b %01010101
 dc.b %00100100
 dc.b %00000000
 dc.b %01100010
 dc.b %00110000
 dc.b %00110010
 dc.b %01100010
 dc.b %00110000
 dc.b %00100010
 dc.b %00100010
 dc.b %00100000
 dc.b %01100010
 dc.b %00110010
 dc.b %01100000
 dc.b %01011010
 dc.b %00000000
 dc.b %00000000
 dc.b %00000000 ;Alignment byte, do not delete !

;Sprites for arrows

LeftArrow:
 dc.w 3 ;Vertical size
 dc.w 1 ;Horizontal size
 dc.b %01001000
 dc.b %11111000
 dc.b %01001000,0

RightArrow:
 dc.w 3 ;Vertical size
 dc.w 1 ;Horizontal size
 dc.b %10010000
 dc.b %11111000
 dc.b %10010000,0

TopArrow:
 dc.w 5 ;Vertical size
 dc.w 1 ;Horizontal size
 dc.b %01000000
 dc.b %11100000
 dc.b %01000000
 dc.b %01000000
 dc.b %11100000,0

BottomArrow:
 dc.w 5 ;Vertical size
 dc.w 1 ;Horizontal size
 dc.b %11100000
 dc.b %01000000
 dc.b %01000000
 dc.b %11100000
 dc.b %01000000,0


TextAddr	dc.l 0  ;Address of text data
TextSize	dc.w 0  ;Size of Text (Vat size)
NLine		dc.w 0  ;Number of lines in the text
MaxChar	dc.w 0  ;Number maximum of chars in one line

CurrentLine	dc.w 0  ;Current line in the text
CurrentChar	dc.w 0  ;Current character for each line
NLineOnScr	dc.w 0  ;Number of text lines on the screen in one time
NCharOnScr	dc.w 0  ;Number of chars on the screen in one time
CurrentFont	dc.l 0  ;Address of current font

NFile		dc.w 0  ;Number of files open
CurrentFile	dc.w 0  ;Index of the current open file (0-9)

Files		dc.l 0  ;List of all files currently open
		dc.w 0  ;Current Line for file
		dc.w 0  ;Current Char for file

		dc.l 0
		dc.w 0  ;Current Line for file
		dc.w 0  ;Current Char for file

		dc.l 0
		dc.w 0  ;Current Line for file
		dc.w 0  ;Current Char for file

		dc.l 0
		dc.w 0  ;Current Line for file
		dc.w 0  ;Current Char for file

		dc.l 0
		dc.w 0  ;Current Line for file
		dc.w 0  ;Current Char for file

OldInterrupt	dc.l 0


;FontName	dc.b "fnt",0

WriteMode	dc.w 0    ;0 -> Write a text char, else write a 32 char

;HelpCommand	dc.b "F1 = HELP",0 ;Help command string (bottom left)
HelpCommand	dc.b "         ",0 ;Help command string (bottom left)
NFileStr	dc.b "   File(s)",0,0 ;Number of files

FontID		dc.b "_Fnt",0,0

Title1		dc.b "  MulDeR v1.0 by CandyMan",0
Title2		dc.b "       Choose a text",0,0
Title3		dc.b "       Choose a font",0,0

;mask for using Browslib
TextMask:
	dc.b %00000010              ;Choose only ID type
	dc.b 0                      ;extra byte, not used
	dc.l 0                      ;No use for text
	dc.w 1                      ;number of type -> 1
	dc.b 224                    ;ID text

;============ For word alignement only ============ 
	dc.b 0
;==================================================

FontMask:
	dc.b %00000011
	dc.b 0                      ;extra byte, not used
	dc.l FontID                 ;Address of first byte ID
	dc.w 1                      ;Number of type -> 1
	dc.b 45                     ;ID String

;============ For word alignement only ============
	dc.b 0
;==================================================


_comment	dc.b 32,"MulDeR V1.0 by CandyMan",32,0

	BSS
StrToWrite	ds.b 40           ;Buffer for each line

	end